/*
 * @file BrokeredClient_Module_Im.c
 * Module Interface for Module BrokeredClient_Module_Im
 */

#include <stdio.h>
#include "BrokeredClient_Module_Im.h"

void BrokeredClient_Module_Im__INITIALIZE__received(BrokeredClient_Module_Im__context *context)
{
   /* User Code Here */
}

void BrokeredClient_Module_Im__START__received(BrokeredClient_Module_Im__context *context)
{
   /* User Code Here */
}

void BrokeredClient_Module_Im__STOP__received(BrokeredClient_Module_Im__context *context)
{
   /* User Code Here */
}

void BrokeredClient_Module_Im__SHUTDOWN__received(BrokeredClient_Module_Im__context *context)
{
   /* User Code Here */
}

void BrokeredClient_Module_Im__tick__received(BrokeredClient_Module_Im__context *context)
{
   BrokeredClient_Module_Im_container__Available_handle availableHandle;

   // First check the service is available.
   ECOA__return_status return_status =  BrokeredClient_Module_Im_container__Available__get_read_access(context, &availableHandle);

   if (return_status == ECOA__return_status_OK)
   {
      if (*(availableHandle.data) == ECOA__TRUE)
      {
         ECOA__global_time time;
         example__value_type val;
         ECOA__log log;

         return_status = BrokeredClient_Module_Im_container__get_absolute_system_time(context, &time);

         val = 0;

         log.current_size = sprintf((char *) &log.data, "BrokeredClient - val before request = %d", val);
         BrokeredClient_Module_Im_container__log_info(context, log);

         return_status = BrokeredClient_Module_Im_container__Request_Val__request_sync(context, &time, &val);

         log.current_size = sprintf((char *) &log.data, "BrokeredClient - val from response = %d", val);
         BrokeredClient_Module_Im_container__log_info(context, log);
      }

      return_status = BrokeredClient_Module_Im_container__Available__release_read_access(context, &availableHandle);
   }

}

