/* @file ServiceBroker_Module_Im_user_context.h
 * This is an example of a user defined User Module context
 */

#if !defined(SERVICEBROKER_MODULE_IM_USER_CONTEXT_H)
#define SERVICEBROKER_MODULE_IM_USER_CONTEXT_H

#if defined(__cplusplus)
extern "C" {
#endif /* __cplusplus */

/* Container Types */
#include "ServiceBroker_Module_Im_container_types.h"

/* User Module Context structure example */
typedef struct
{
   /* declare the User Module Context "local" data here */
   ECOA__boolean8 preferredAvailable;
   ECOA__boolean8 backupAvailable;
} ServiceBroker_Module_Im_user_context;

#if defined(__cplusplus)
}
#endif /* __cplusplus */

#endif  /* SERVICEBROKER_MODULE_IM_USER_CONTEXT_H */
